%%% -*- TeX-command-extra-options: "-shell-escape" -*-
%%% Local IspellDict: en

% Figure "Processes vs Threads" based on Anderson et al. (1997): Thread
% Management for Shared-Memory Multiprocessors
%
% Copyright (C) 2018 Jens Lechtenbörger
% License: CC BY-SA 4.0, https://creativecommons.org/licenses/by-sa/4.0/
% Source: https://gitlab.com/oer/figures/blob/master/OS/tikz/processes-vs-threads.tex

\documentclass[convert={outext=.png}]{standalone}
% Use sans-serif by default:
\renewcommand{\familydefault}{\sfdefault}

\usepackage{tikz}
\newcommand{\thread}[2]{
  \draw[very thick, xshift=#1cm, yshift=#2cm] plot [smooth,tension=0.7] coordinates {(0,2) (0.3,1.75) (-0.2,1.25) (0.4,0.5) (0,0)};
}

\begin{document}
\begin{tikzpicture}[
  process/.style={rounded corners=0.5cm,
    minimum width=2cm,
    minimum height=3cm,
    draw=blue!50!black!50,
    top color=white,
    bottom color=blue!50!black!20,
  }]

  \draw [gray!50] (-5,0) -- (5,0);
  \draw [gray!50] (0,-5) -- (0,5);
  \node (q1) at (0.4, 0.3) {Q1};
  \node at (2.5, 4.5) {Single process, multiple threads};
  \node (p1) at (2.5, 2.5) [process] {};
  \thread{2.2}{1.5}
  \thread{2.4}{1.5}
  \thread{2.6}{1.5}
  \thread{2.8}{1.5}

  \node (q2) at (-0.4, 0.3) {Q2};
  \node at (-2.5, 4.5) {Single process, single thread};
  \node (p2) at (-2.5, 2.5) [process] {};
  \thread{-2.5}{1.5}

  \node (q3) at (-0.4, -0.3) {Q3};
  \node at (-2.8, -4.5) {Multiple processes, single thread};
  \node (p3a) at (-4, -2.5) [process] {};
  \node (p3b) at (-1.5, -2.5) [process] {};
  \thread{-1.5}{-3.5}
  \thread{-4}{-3.5}

  \node (q4) at (0.4, -0.3) {Q4};
  \node at (3, -4.5) {Multiple processes, multiple threads};
  \node (p4a) at (4, -2.5) [process] {};
  \node (p4b) at (1.5, -2.5) [process] {};
  \thread{1.2}{-3.5}
  \thread{1.4}{-3.5}
  \thread{1.6}{-3.5}
  \thread{3.5}{-3.5}
  \thread{3.7}{-3.5}
  \thread{3.9}{-3.5}
  \thread{4.1}{-3.5}
  \thread{4.3}{-3.5}

\end{tikzpicture}
\end{document}
